diff --git a/ChangeLog.d/bugfix/ZBX-23688 b/ChangeLog.d/bugfix/ZBX-23688
new file mode 100644
index 00000000000..8bc5e9c0ff5
--- /dev/null
+++ b/ChangeLog.d/bugfix/ZBX-23688
@@ -0,0 +1 @@
+........S. [ZBX-23688] improved new item value retrieval performance by adding such items to value cache after configuration sync (wiper)
diff --git a/include/zbxcacheconfig.h b/include/zbxcacheconfig.h
index 9767f126b41..0d31a6c9b52 100644
--- a/include/zbxcacheconfig.h
+++ b/include/zbxcacheconfig.h
@@ -226,6 +226,7 @@ typedef struct
 	unsigned char		status;
 	unsigned char		history;
 	unsigned char		trends;
+	unsigned char		has_trigger;
 }
 zbx_history_sync_item_t;
 
@@ -873,14 +874,6 @@ void	zbx_dc_correlation_rules_get(zbx_correlation_rules_t *rules);
 void	zbx_dc_get_nested_hostgroupids(zbx_uint64_t *groupids, int groupids_num, zbx_vector_uint64_t *nested_groupids);
 void	zbx_dc_get_hostids_by_group_name(const char *name, zbx_vector_uint64_t *hostids);
 
-
-#define ZBX_DC_FLAG_META	0x01	/* contains meta information (lastlogsize and mtime) */
-#define ZBX_DC_FLAG_NOVALUE	0x02	/* entry contains no value */
-#define ZBX_DC_FLAG_LLD		0x04	/* low-level discovery value */
-#define ZBX_DC_FLAG_UNDEF	0x08	/* unsupported or undefined (delta calculation failed) value */
-#define ZBX_DC_FLAG_NOHISTORY	0x10	/* values should not be kept in history */
-#define ZBX_DC_FLAG_NOTRENDS	0x20	/* values should not be kept in trends */
-
 typedef struct zbx_hc_data
 {
 	zbx_history_value_t	value;
diff --git a/include/zbxcachevalue.h b/include/zbxcachevalue.h
index 19d6166c205..38e7f55baa9 100644
--- a/include/zbxcachevalue.h
+++ b/include/zbxcachevalue.h
@@ -119,4 +119,6 @@ void	zbx_vc_get_mem_stats(zbx_shmem_stats_t *mem);
 void	zbx_vc_get_item_stats(zbx_vector_ptr_t *stats);
 void	zbx_vc_flush_stats(void);
 
+void	zbx_vc_add_new_items(const zbx_vector_uint64_pair_t *items);
+
 #endif
diff --git a/include/zbxcommon.h b/include/zbxcommon.h
index 12657505e94..40e9b7c5388 100644
--- a/include/zbxcommon.h
+++ b/include/zbxcommon.h
@@ -804,6 +804,14 @@ zbx_tag_t;
 /* time and memory size suffixes */
 zbx_uint64_t	suffix2factor(char c);
 
+#define ZBX_DC_FLAG_META	0x01	/* contains meta information (lastlogsize and mtime) */
+#define ZBX_DC_FLAG_NOVALUE	0x02	/* entry contains no value */
+#define ZBX_DC_FLAG_LLD		0x04	/* low-level discovery value */
+#define ZBX_DC_FLAG_UNDEF	0x08	/* unsupported or undefined (delta calculation failed) value */
+#define ZBX_DC_FLAG_NOHISTORY	0x10	/* values should not be kept in history */
+#define ZBX_DC_FLAG_NOTRENDS	0x20	/* values should not be kept in trends */
+#define ZBX_DC_FLAG_HASTRIGGER	0x40	/* value is used in trigger expression */
+
 /******************************************************************************
  *                                                                            *
  * CODE BELOW IS LIBC WRAPPERS WHICH COULD BE LATER MOVED TO SEPARATE LIBRARY *
diff --git a/src/libs/zbxcacheconfig/dbconfig.c b/src/libs/zbxcacheconfig/dbconfig.c
index b68683fa630..779eeaedada 100644
--- a/src/libs/zbxcacheconfig/dbconfig.c
+++ b/src/libs/zbxcacheconfig/dbconfig.c
@@ -46,6 +46,7 @@
 #include "zbxpreproc.h"
 #include "zbxcachehistory.h"
 #include "zbxconnector.h"
+#include "zbxcachevalue.h"
 
 int	sync_in_progress = 0;
 
@@ -2654,7 +2655,7 @@ static void	dc_preprocitem_free(ZBX_DC_PREPROCITEM *preprocitem)
 }
 
 static void	DCsync_items(zbx_dbsync_t *sync, zbx_uint64_t revision, int flags, zbx_synced_new_config_t synced,
-		zbx_vector_uint64_t *deleted_itemids)
+		zbx_vector_uint64_t *deleted_itemids, zbx_vector_dc_item_ptr_t *new_items)
 {
 	char			**row;
 	zbx_uint64_t		rowid;
@@ -2794,6 +2795,9 @@ static void	DCsync_items(zbx_dbsync_t *sync, zbx_uint64_t revision, int flags, z
 
 			item->preproc_item = NULL;
 			item->master_item = NULL;
+
+			if (NULL != new_items)
+				zbx_vector_dc_item_ptr_append(new_items, item);
 		}
 		else
 		{
@@ -6828,6 +6832,41 @@ static void	DCsync_connector_tags(zbx_dbsync_t *sync)
 	zabbix_log(LOG_LEVEL_DEBUG, "End of %s()", __func__);
 }
 
+/******************************************************************************
+ *                                                                            *
+ * Purpose: add new items with triggers to value cache                        *
+ *                                                                            *
+ ******************************************************************************/
+static void	dc_add_new_items_to_valuecache(const zbx_vector_dc_item_ptr_t *items)
+{
+	if (0 != items->values_num)
+	{
+		zbx_vector_uint64_pair_t	vc_items;
+		int				i;
+
+		zbx_vector_uint64_pair_create(&vc_items);
+		zbx_vector_uint64_pair_reserve(&vc_items, items->values_num);
+
+		for (i = 0; i < items->values_num; i++)
+		{
+			if (0 != items->values[i]->update_triggers)
+			{
+				zbx_uint64_pair_t	pair = {
+						.first = items->values[i]->itemid,
+						.second = (zbx_uint64_t)items->values[i]->value_type
+				};
+
+				zbx_vector_uint64_pair_append_ptr(&vc_items, &pair);
+			}
+		}
+
+		if (0 != items->values_num)
+			zbx_vc_add_new_items(&vc_items);
+
+		zbx_vector_uint64_pair_destroy(&vc_items);
+	}
+}
+
 /******************************************************************************
  *                                                                            *
  * Purpose: Synchronize configuration data from database                      *
@@ -6863,11 +6902,12 @@ void	DCsync_configuration(unsigned char mode, zbx_synced_new_config_t synced, zb
 	zbx_uint64_t	update_flags = 0;
 	unsigned char	changelog_sync_mode = mode;	/* sync mode for objects using incremental sync */
 
-	zbx_hashset_t		trend_queue;
-	zbx_vector_uint64_t	active_avail_diff;
-	zbx_hashset_t		activated_hosts;
-	zbx_uint64_t		new_revision = config->revision.config + 1;
-	int			connectors_num = 0;
+	zbx_hashset_t			trend_queue;
+	zbx_vector_uint64_t		active_avail_diff;
+	zbx_hashset_t			activated_hosts;
+	zbx_uint64_t			new_revision = config->revision.config + 1;
+	int				connectors_num = 0;
+	zbx_vector_dc_item_ptr_t	new_items, *pnew_items = NULL;
 
 	zabbix_log(LOG_LEVEL_DEBUG, "In %s()", __func__);
 
@@ -6883,7 +6923,14 @@ void	DCsync_configuration(unsigned char mode, zbx_synced_new_config_t synced, zb
 		dc_load_trigger_queue(&trend_queue);
 	}
 	else if (ZBX_DBSYNC_STATUS_INITIALIZED != sync_status)
+	{
 		changelog_sync_mode = ZBX_DBSYNC_INIT;
+	}
+	else if (0 != (program_type & ZBX_PROGRAM_TYPE_SERVER))
+	{
+		zbx_vector_dc_item_ptr_create(&new_items);
+		pnew_items = &new_items;
+	}
 
 	/* global configuration must be synchronized directly with database */
 	zbx_dbsync_init(&config_sync, ZBX_DBSYNC_INIT);
@@ -7162,6 +7209,11 @@ void	DCsync_configuration(unsigned char mode, zbx_synced_new_config_t synced, zb
 		goto out;
 	itemscrp_sec = zbx_time() - sec;
 
+	sec = zbx_time();
+	if (FAIL == zbx_dbsync_compare_functions(&func_sync))
+		goto out;
+	fsec = zbx_time() - sec;
+
 	START_SYNC;
 
 	/* resolves macros for interface_snmpaddrs, must be after DCsync_hmacros() */
@@ -7172,7 +7224,7 @@ void	DCsync_configuration(unsigned char mode, zbx_synced_new_config_t synced, zb
 	/* relies on hosts, proxies and interfaces, must be after DCsync_{hosts,interfaces}() */
 
 	sec = zbx_time();
-	DCsync_items(&items_sync, new_revision, flags, synced, deleted_itemids);
+	DCsync_items(&items_sync, new_revision, flags, synced, deleted_itemids, pnew_items);
 	isec2 = zbx_time() - sec;
 
 	sec = zbx_time();
@@ -7197,29 +7249,17 @@ void	DCsync_configuration(unsigned char mode, zbx_synced_new_config_t synced, zb
 	DCsync_itemscript_param(&itemscrp_sync, new_revision);
 	itemscrp_sec2 = zbx_time() - sec;
 
-	FINISH_SYNC;
-
-	dc_flush_history();	/* misconfigured items generate pseudo-historic values to become notsupported */
-
-	/* sync function data to support function lookups when resolving macros during configuration sync */
-
-	/* relies on items, must be after DCsync_items() */
-	sec = zbx_time();
-	if (FAIL == zbx_dbsync_compare_item_tags(&item_tag_sync))
-		goto out;
-	item_tag_sec = zbx_time() - sec;
-
-	sec = zbx_time();
-	if (FAIL == zbx_dbsync_compare_functions(&func_sync))
-		goto out;
-	fsec = zbx_time() - sec;
-
-	START_SYNC;
 	sec = zbx_time();
 	DCsync_functions(&func_sync, new_revision);
 	fsec2 = zbx_time() - sec;
+
 	FINISH_SYNC;
 
+	if (NULL != pnew_items)
+		dc_add_new_items_to_valuecache(pnew_items);
+
+	dc_flush_history();	/* misconfigured items generate pseudo-historic values to become notsupported */
+
 	/* sync rest of the data */
 	sec = zbx_time();
 	if (FAIL == zbx_dbsync_compare_triggers(&triggers_sync))
@@ -7256,6 +7296,12 @@ void	DCsync_configuration(unsigned char mode, zbx_synced_new_config_t synced, zb
 		goto out;
 	trigger_tag_sec = zbx_time() - sec;
 
+	/* relies on items, must be after DCsync_items() */
+	sec = zbx_time();
+	if (FAIL == zbx_dbsync_compare_item_tags(&item_tag_sync))
+		goto out;
+	item_tag_sec = zbx_time() - sec;
+
 	sec = zbx_time();
 	if (FAIL == zbx_dbsync_compare_correlations(&correlation_sync))
 		goto out;
@@ -7802,6 +7848,9 @@ clean:
 	if (ZBX_DBSYNC_INIT == mode)
 		zbx_hashset_destroy(&trend_queue);
 
+	if (NULL != pnew_items)
+		zbx_vector_dc_item_ptr_destroy(pnew_items);
+
 	zbx_dbsync_env_clear();
 
 	zbx_hashset_destroy(&activated_hosts);
diff --git a/src/libs/zbxcacheconfig/dbhistoryconfig.c b/src/libs/zbxcacheconfig/dbhistoryconfig.c
index 69f93343de4..6ed44a3fe3d 100644
--- a/src/libs/zbxcacheconfig/dbhistoryconfig.c
+++ b/src/libs/zbxcacheconfig/dbhistoryconfig.c
@@ -91,6 +91,13 @@ static void	dc_get_history_sync_item(zbx_history_sync_item_t *dst_item, const ZB
 			dst_item->trends_period = NULL;
 			dst_item->units = NULL;
 	}
+
+	/* check also for update_triggers flag to avoid race condition when value is being added */
+	/* after item has been synced but before triggers are linked to it                       */
+	if (NULL != src_item->triggers || 0 != src_item->update_triggers)
+		dst_item->has_trigger = 1;
+	else
+		dst_item->has_trigger = 0;
 }
 
 /******************************************************************************
diff --git a/src/libs/zbxcachehistory/dbcache.c b/src/libs/zbxcachehistory/dbcache.c
index 9b66612dec5..e239fcf70a6 100644
--- a/src/libs/zbxcachehistory/dbcache.c
+++ b/src/libs/zbxcachehistory/dbcache.c
@@ -2986,6 +2986,9 @@ static void	DCmass_prepare_history(ZBX_DC_HISTORY *history, zbx_history_sync_ite
 
 			zbx_vector_uint64_pair_append(proxy_subscribtions, p);
 		}
+
+		if (0 != item->has_trigger)
+			h->flags |= ZBX_DC_FLAG_HASTRIGGER;
 	}
 
 	zbx_vector_ptr_sort(inventory_values, ZBX_DEFAULT_UINT64_PTR_COMPARE_FUNC);
diff --git a/src/libs/zbxcachevalue/valuecache.c b/src/libs/zbxcachevalue/valuecache.c
index e7a3309d4bf..4385975eff4 100644
--- a/src/libs/zbxcachevalue/valuecache.c
+++ b/src/libs/zbxcachevalue/valuecache.c
@@ -2527,7 +2527,22 @@ int	zbx_vc_add_values(zbx_vector_ptr_t *history, int *ret_flush)
 	{
 		h = (ZBX_DC_HISTORY *)history->values[i];
 
-		if (NULL != (item = (zbx_vc_item_t *)zbx_hashset_search(&vc_cache->items, &h->itemid)))
+		item = (zbx_vc_item_t *)zbx_hashset_search(&vc_cache->items, &h->itemid);
+
+		if (NULL == item && 0 != (h->flags & ZBX_DC_FLAG_HASTRIGGER) && ZBX_VC_MODE_NORMAL == vc_cache->mode)
+		{
+			zbx_vc_item_t	item_local = {
+					.itemid = h->itemid,
+					.value_type = h->value_type,
+					.last_accessed = (int)time(NULL)
+
+			};
+
+			item = (zbx_vc_item_t *)zbx_hashset_insert(&vc_cache->items, &item_local, sizeof(item_local));
+		}
+
+		/* cache new values only after the item history database status is known */
+		if (NULL != item && (ZBX_ITEM_STATUS_CACHED_ALL == item->status || 0 != item->db_cached_from))
 		{
 			zbx_history_record_t	record = {h->ts, h->value};
 			zbx_vc_chunk_t		*head = item->head;
@@ -2862,6 +2877,42 @@ void	zbx_vc_flush_stats(void)
 	zbx_vector_vc_itemupdate_clear(&vc_itemupdates);
 }
 
-#ifdef HAVE_TESTS
-#	include "../../../tests/libs/zbxdbcache/valuecache_test.c"
-#endif
+/******************************************************************************
+ *                                                                            *
+ * Purpose: add newly created items with triggers to value cachel              *
+ *                                                                            *
+ ******************************************************************************/
+void	zbx_vc_add_new_items(const zbx_vector_uint64_pair_t *items)
+{
+	if (ZBX_VC_DISABLED == vc_state)
+		return;
+
+	WRLOCK_CACHE;
+
+	if (ZBX_VC_MODE_NORMAL == vc_cache->mode)
+	{
+		int	i;
+
+		for (i = 0; i < items->values_num; i++)
+		{
+			if (NULL != zbx_hashset_search(&vc_cache->items, &items->values[i]))
+				continue;
+
+			zbx_vc_item_t	item_local = {
+					.itemid = items->values[i].first,
+					.value_type = (unsigned char)items->values[i].second,
+					.status = ZBX_ITEM_STATUS_CACHED_ALL,
+					.last_accessed = (int)time(NULL)
+
+			};
+
+			if (NULL == zbx_hashset_insert(&vc_cache->items, &item_local, sizeof(item_local)))
+			{
+				/* out of memory - cache will switch to low memory mode on next caching request */
+				break;
+			}
+		}
+	}
+
+	UNLOCK_CACHE;
+}
diff --git a/tests/libs/zbxdbcache/Makefile.am b/tests/libs/zbxdbcache/Makefile.am
index a6e6f444ef1..12c7174e413 100644
--- a/tests/libs/zbxdbcache/Makefile.am
+++ b/tests/libs/zbxdbcache/Makefile.am
@@ -135,7 +135,7 @@ COMMON_WRAP_FUNCS = \
 zbx_vc_get_values_SOURCES = \
 	zbx_vc_common.c \
 	zbx_vc_get_values.c \
-	@top_srcdir@/src/libs/zbxcachevalue/valuecache.c \
+	valuecache_test.c \
 	@top_srcdir@/src/libs/zbxhistory/history.c \
 	../../zbxmocktest.h
 
@@ -156,7 +156,7 @@ zbx_vc_get_values_CFLAGS = \
 zbx_vc_add_values_SOURCES = \
 	zbx_vc_common.c \
 	zbx_vc_add_values.c \
-	@top_srcdir@/src/libs/zbxcachevalue/valuecache.c \
+	valuecache_test.c \
 	@top_srcdir@/src/libs/zbxhistory/history.c \
 	../../zbxmocktest.h
 
@@ -177,7 +177,7 @@ zbx_vc_add_values_CFLAGS = \
 zbx_vc_get_value_SOURCES = \
 	zbx_vc_common.c \
 	zbx_vc_get_value.c \
-	@top_srcdir@/src/libs/zbxcachevalue/valuecache.c \
+	valuecache_test.c \
 	@top_srcdir@/src/libs/zbxhistory/history.c \
 	../../zbxmocktest.h
 
diff --git a/tests/libs/zbxdbcache/valuecache_test.c b/tests/libs/zbxdbcache/valuecache_test.c
index 934fc1399cc..612a940e6c4 100644
--- a/tests/libs/zbxdbcache/valuecache_test.c
+++ b/tests/libs/zbxdbcache/valuecache_test.c
@@ -17,7 +17,10 @@
 ** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 **/
 
+#include "../../../src/libs/zbxcachevalue/valuecache.c"
+
 #include "valuecache_test.h"
+#include "zbxmocktest.h"
 
 void	zbx_vc_set_mode(int mode)
 {
@@ -104,3 +107,45 @@ int	zbx_vc_get_cache_state(int *mode, zbx_uint64_t *hits, zbx_uint64_t *misses)
 
 	return SUCCEED;
 }
+
+/*
+ * cache working mode handling
+ */
+
+/******************************************************************************
+ *                                                                            *
+ * Purpose: sets value cache mode if the specified key is present in input    *
+ *          data                                                              *
+ *                                                                            *
+ ******************************************************************************/
+void	zbx_vcmock_set_mode(zbx_mock_handle_t hitem, const char *key)
+{
+	const char		*data;
+	zbx_mock_handle_t	hmode;
+	zbx_mock_error_t	err;
+
+	if (ZBX_MOCK_SUCCESS == zbx_mock_object_member(hitem, key, &hmode))
+	{
+		if (ZBX_MOCK_SUCCESS != (err = zbx_mock_string(hmode, &data)))
+			fail_msg("Cannot read \"%s\" parameter: %s", key, zbx_mock_error_string(err));
+
+		zbx_vc_set_mode(zbx_vcmock_str_to_cache_mode(data));
+	}
+}
+
+/******************************************************************************
+ *                                                                            *
+ * Purpose: converts value cache mode from text format                        *
+ *                                                                            *
+ ******************************************************************************/
+int	zbx_vcmock_str_to_cache_mode(const char *mode)
+{
+	if (0 == strcmp(mode, "ZBX_VC_MODE_NORMAL"))
+		return ZBX_VC_MODE_NORMAL;
+
+	if (0 == strcmp(mode, "ZBX_VC_MODE_LOWMEM"))
+		return ZBX_VC_MODE_LOWMEM;
+
+	fail_msg("Unknown value cache mode \"%s\"", mode);
+	return FAIL;
+}
diff --git a/tests/libs/zbxdbcache/valuecache_test.h b/tests/libs/zbxdbcache/valuecache_test.h
index 07dcd14d040..362b1deea3d 100644
--- a/tests/libs/zbxdbcache/valuecache_test.h
+++ b/tests/libs/zbxdbcache/valuecache_test.h
@@ -20,6 +20,8 @@
 #ifndef ZABBIX_VALUECACHE_TEST_H
 #define ZABBIX_VALUECACHE_TEST_H
 
+#include "zbxmockdata.h"
+
 void	zbx_vc_set_mode(int mode);
 int	zbx_vc_get_cached_values(zbx_uint64_t itemid, unsigned char value_type, zbx_vector_history_record_t *values);
 int	zbx_vc_precache_values(zbx_uint64_t itemid, int value_type, int seconds, int count, const zbx_timespec_t *ts);
@@ -27,4 +29,7 @@ int	zbx_vc_get_item_state(zbx_uint64_t itemid, int *status, int *active_range, i
 		int *db_cached_from);
 int	zbx_vc_get_cache_state(int *mode, zbx_uint64_t *hits, zbx_uint64_t *misses);
 
+void	zbx_vcmock_set_mode(zbx_mock_handle_t hitem, const char *key);
+int	zbx_vcmock_str_to_cache_mode(const char *mode);
+
 #endif
diff --git a/tests/mocks/valuecache/valuecache_mock.c b/tests/mocks/valuecache/valuecache_mock.c
index 690c45407c1..7ab433dfc70 100644
--- a/tests/mocks/valuecache/valuecache_mock.c
+++ b/tests/mocks/valuecache/valuecache_mock.c
@@ -327,23 +327,6 @@ zbx_vcmock_ds_item_t	*zbx_vcmock_ds_first_item(void)
 	return (zbx_vcmock_ds_item_t *)zbx_hashset_iter_next(&iter);
 }
 
-/******************************************************************************
- *                                                                            *
- * Purpose: converts value cache mode from text format                        *
- *                                                                            *
- ******************************************************************************/
-int	zbx_vcmock_str_to_cache_mode(const char *mode)
-{
-	if (0 == strcmp(mode, "ZBX_VC_MODE_NORMAL"))
-		return ZBX_VC_MODE_NORMAL;
-
-	if (0 == strcmp(mode, "ZBX_VC_MODE_LOWMEM"))
-		return ZBX_VC_MODE_LOWMEM;
-
-	fail_msg("Unknown value cache mode \"%s\"", mode);
-	return FAIL;
-}
-
 /******************************************************************************
  *                                                                            *
  * Purpose: converts value cache item status from text format                 *
@@ -742,31 +725,6 @@ void	zbx_vcmock_get_request_params(zbx_mock_handle_t handle, zbx_uint64_t *itemi
 	zbx_strtime_to_timespec(zbx_mock_get_object_member_string(handle, "end"), end);
 }
 
-/*
- * cache working mode handling
- */
-
-/******************************************************************************
- *                                                                            *
- * Purpose: sets value cache mode if the specified key is present in input    *
- *          data                                                              *
- *                                                                            *
- ******************************************************************************/
-void	zbx_vcmock_set_mode(zbx_mock_handle_t hitem, const char *key)
-{
-	const char		*data;
-	zbx_mock_handle_t	hmode;
-	zbx_mock_error_t	err;
-
-	if (ZBX_MOCK_SUCCESS == zbx_mock_object_member(hitem, key, &hmode))
-	{
-		if (ZBX_MOCK_SUCCESS != (err = zbx_mock_string(hmode, &data)))
-			fail_msg("Cannot read \"%s\" parameter: %s", key, zbx_mock_error_string(err));
-
-		zbx_vc_set_mode(zbx_vcmock_str_to_cache_mode(data));
-	}
-}
-
 /*
  * time() emulation
  */
diff --git a/tests/mocks/valuecache/valuecache_mock.h b/tests/mocks/valuecache/valuecache_mock.h
index ba396e1b8f3..391beac1363 100644
--- a/tests/mocks/valuecache/valuecache_mock.h
+++ b/tests/mocks/valuecache/valuecache_mock.h
@@ -41,7 +41,6 @@ void	zbx_vcmock_ds_destroy(void);
 void	zbx_vcmock_ds_dump(void);
 zbx_vcmock_ds_item_t	*zbx_vcmock_ds_first_item(void);
 
-int	zbx_vcmock_str_to_cache_mode(const char *mode);
 int	zbx_vcmock_str_to_item_status(const char *str);
 
 void	zbx_vcmock_read_values(zbx_mock_handle_t hdata, unsigned char value_type, zbx_vector_history_record_t *values);
@@ -56,7 +55,6 @@ zbx_timespec_t	zbx_vcmock_get_ts(void);
 void	zbx_vcmock_set_cache_size(zbx_mock_handle_t hitem, const char *key);
 void	zbx_vcmock_get_request_params(zbx_mock_handle_t handle, zbx_uint64_t *itemid, unsigned char *value_type,
 		int *seconds, int *count, zbx_timespec_t *end);
-void	zbx_vcmock_set_mode(zbx_mock_handle_t hitem, const char *key);
 
 void	zbx_vcmock_get_dc_history(zbx_mock_handle_t handle, zbx_vector_ptr_t *history);
 void	zbx_vcmock_free_dc_history(void *ptr);